void get_buffer_data(fs, log_p, buffer, bp, lbn, offset, size)
     struct fs *fs;
     struct dinode *log_p;
     char *buffer;
     struct bufarea **bp;
     int *lbn;
     int offset;
     int size;
{
  /*
   * figure out if the size will cross block boundaries
   */
  if(offset + size <= fs->fs_bsize) {
    /*
     * if it doesn't just copy out
     */
    /*    printf("\t\t\t*** reading buffer for lbn %d at offset %d\n", *lbn, offset); */
    memcpy(buffer, (*bp)->b_un.b_buf+offset, size);

    printf("final size: %d %d\n", offset + size, fs->fs_bsize);
    if((offset + size) == fs->fs_bsize) {
      printf("YAYA\n");
      (*lbn)++;
      (*bp) = getdatablk(get_block(log_p, *lbn), fs->fs_bsize);
    }
  } else {
    int p1 = fs->fs_bsize - offset;
    int p2 = size - p1;

    /*
     * if it does, we need to get the next block too and copy some from there
     */
    printf("offset: %d, size %d\n", offset, size);
    memcpy(buffer, (*bp)->b_un.b_buf+offset, p1);
    printf("buffer-> 0: %d, 1: %d, 2: %d\n", 
	   ((int *)buffer)[0], ((int *)buffer)[1], ((int *)buffer)[2]);
    /*    printf("\t\t\t*** reading buffer for lbn %d and ", *lbn); */
    (*lbn)++;
    if((*lbn + 1) * fs->fs_bsize > log_p->di_size) {
      *lbn = 0;
    }

    printf("lbn: %d, p1: %d, p2: %d", *lbn, p1, p2);
    *bp = getdatablk(get_block(log_p, *lbn), fs->fs_bsize);

    memcpy(buffer + p1, (*bp)->b_un.b_buf, p2);
    printf("buffer-> 0: %d, 1: %d, 2: %d\n", 
	   ((int *)buffer)[0], ((int *)buffer)[1], ((int *)buffer)[2]);
    printf("buffer-> %d", buffer[p1]);
  }
}


  /*
   * get the log inode
   */
  log_p = ginode((ino_t)LOGGING_INO);
  
  /*
   * read in the first block of the log
   */
  i = 0;
  printf("CRUCIAL -- READING IN THE LOG FILE BLOCK %d : %d; %d; %d\n", i,
	 log_p->di_size, fs->fs_bsize, (log_p->di_size / fs->fs_bsize));
  bp = getdatablk(get_block(log_p, lbn), fs->fs_bsize);
  
  /*
   * grab the start and size of the log on this block
   */ 
  log_start = fs->fs_log_start;

  /* set the logical block number */
  lbn = log_start / fs->fs_bsize;
  printf("lbn: %d\n", lbn);
  printf("log start: %d\n", log_start);
  
  /*
   * loop through the log entries in the block
   */
  j = log_start;
  while(get_log_entry(fs, log_p, &bp, &j, buffer)) {
    /*
     * access the buffer as integers
     */
    log_buf = (int *)(buffer);

    /*
     * get the command
     */
    command = log_buf[0];
    printf("Got a command: %d %d\n", command, lbn);
    
    switch(command) {
    case(LOGGING_ADDDIRECT):
      printf("Adding direct pointer\n");
      break;

      /*
       * get the proper dinode
       */
      printf("\tgetting the inode %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);
      
      printf("\tthe inode: %d, the lbn: %d, the pbn: %d\n",
	     log_buf[3], log_buf[4], log_buf[5]);
      /*
       * set the direct block to the correct physical block
       */
      file_p->di_db[log_buf[4]] = log_buf[5];
      inodirty();
      break;
    case(LOGGING_UPDATEBLKMAP):
      printf("Updating the block map\n");
      break;

      /*
       * updating the block map
       */
      printf("trying to allocate fragments starting at %d and going for %d\n",
	     log_buf[3], log_buf[4]);
      alloc_frags(log_buf[3], log_buf[4]);
      break;
    case(LOGGING_UPDATEINOMAP):
      printf("Updating the inode map\n");
      break;

      /*
       * update the inode map
       */
      printf("\tallocating an inode: %d\n", log_buf[3]);
      alloc_inode(log_buf[3]);

      /*
       * "allocate" the inode (zero it out?)
       */
      printf("\tgetting an inode: %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);
      printf("\tgot an inode: %d\n", file_p->di_inumber);
      file_p->di_flags = 0;
      printf("\tsetting the mode to be: %d\n", log_buf[4]);
      file_p->di_mode = log_buf[4];
      file_p->di_atime = file_p->di_ctime = file_p->di_mtime = log_buf[1];
      file_p->di_atimensec = file_p->di_ctimensec = 
	file_p->di_mtimensec = log_buf[2];
      file_p->di_size = 0;
      file_p->di_blocks = 0;
      inodirty();
	
      break;
    case(LOGGING_FREEINODE):
      printf("Freeing an inode\n");
      break;

      /*
       * set the info for the inode to be zero'ed out
       */
      printf("\tInode: %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);
      file_p->di_nlink = 0;
      file_p->di_mode = 0;
      file_p->di_size = 0;
      file_p->di_blocks = 0;
      file_p->di_flags = 0;
      inodirty();

      /*
       * update the inode map
       */
      free_inode(log_buf[3]);

      break;
    case(LOGGING_ADDDIRENTRY):
      printf("Adding a directory entry\n");
      break;

      /*
       * get the directory entry
       */
      memcpy(&dir_entry, buffer + sizeof(int)*7, 8);
      memcpy(&(dir_entry.d_name), buffer + sizeof(int)*7 + 8,
	     dir_entry.d_namelen);
      dir_entry.d_name[dir_entry.d_namlen] = 0;

      printf("\tInode: %d\n", log_buf[3]);
      printf("\tat offset: %d\n", log_buf[4]);
      printf("\tentry ->\n");
      printf("\t\tinode %d\n", dir_entry.d_ino);
      printf("\t\trecord length %d\n", dir_entry.d_reclen);
      printf("\t\ttype %d\n", dir_entry.d_type);
      printf("\t\tname length %d\n", dir_entry.d_namlen);
      printf("\t\tname %s\n", dir_entry.d_name);

      /* 
       * get the dinode and the lbn
       */
      offset = log_buf[4];
      printf("\tgetting an inode %d\n", log_buf[3]);
      dir_p = ginode(log_buf[3]);
      dlbn = offset/fs->fs_bsize;

      /*
       * get the block from the offset
       */
      printf("\tlogical block number %d\n", dlbn);
      dir_bp = getdatablk(get_block(dir_p, dlbn), fs->fs_bsize);

      /*
       * update the directory entry
       */
      offset = offset - dlbn * fs->fs_bsize;
      memcpy(dir_bp->b_un.b_buf + offset, &dir_entry, 8 + dir_entry.d_namlen);

      /*
       * need to correct the previous entry's rec_len
       */
      if(log_buf[2] != 0) {
	short temp;
	/*
	 * we have the previous entry's size, set it
	 */
	printf("previous entry's size: %d\n", log_buf[5]);
	temp = log_buf[5];
	memcpy(dir_bp->b_un.b_buf + offset - log_buf[5] + 4,
	       &(temp), sizeof(short));
      } else {
	/*
	 * we are the first entry in the directory
	 * we should update the size?
	 */
	/* note: 512 temporary */
	dir_p->di_size = ((offset / 512) + 1) * 512;
	printf("directory inode size: %d\n", dir_p->di_size);
	inodirty();
      }

      /* 
       * write out the block
       */
      dirty(dir_bp);
      break;
    case(LOGGING_REMDIRENTRY):
      printf("Removing a directory entry\n");
      break;

      /*
       * get the dinode of the directory
       */
      printf("\tgetting an inode %d\n", log_buf[3]);
      dir_p = ginode(log_buf[3]);

      printf("\tabout to remove entry at offset %d\n", log_buf[4]);
      printf("\tabout to update entry at offset %d\n", log_buf[4]-log_buf[5]);
      printf("\tinode reclen: %d\n", log_buf[6]);

      /*
       * clear the directory entry at the given offset
       */
      inum = free_dir_entry(dir_p, log_buf[4], log_buf[5], log_buf[6]);
      break;
    case(LOGGING_CHANGEDIRENTRY):
      printf("Changing a directory entry\n");
      break;

      /*
       * get the dinode of the directory
       */
      printf("\tgetting an inode %d\n", log_buf[3]);
      dir_p = ginode(log_buf[3]);

      /*
       * change the directory entry
       */
      inum = change_dir_entry(dir_p, log_buf[4], log_buf[5]);
      break;
    case(LOGGING_INCLINKCNT):
      printf("Setting the link count on a file\n");
      break;
	
      /* increase the link count on the given inode */
      printf("\tgetting inode %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);
      printf("\tgot inode %d\n", file_p->di_inumber);
      file_p->di_nlink = log_buf[4];
      printf("\tset the link count to %d\n", file_p->di_nlink);
      inodirty();
      break;
    case(LOGGING_SETINDIRMETA):
      printf("Setting the indirect meta data\n");
      break;
    case(LOGGING_ADDINDIRPAGE):
      printf("Adding an indirect meta data page\n");
      break;

      /*
       * get the dinode of the file
       */
      printf("\tgetting an inode %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);

      printf("\tthe size %d; the number of blocks %d, %d, %d, %d\n", 
	     file_p->di_size, file_p->di_blocks, fs->fs_fsize,
	     btodb(fs->fs_fsize));

      /*
       * set the logical block number
       */
      set_block(file_p, log_buf[4], log_buf[5]);
      break;
    case(LOGGING_CHANGESIZE):
      printf("Changing the size of a file\n");
      break;

      printf("\tgetting an inode %d\n", log_buf[3]);
      printf("\tchanged to size %d\n", log_buf[4]);
      printf("\tset num blocks to %d\n", log_buf[5]);
      file_p = ginode(log_buf[3]);
      file_p->di_size = log_buf[4];
      file_p->di_blocks = log_buf[5];
      inodirty();
      break;
    case(LOGGING_FREEFRAGS):
      printf("Freeing fragments\n");
      break;

      printf("\tfreeing %d fragments: start block %d\n",
	     log_buf[4], log_buf[3]);
      /*
       * free y fragments at block x
       */
      free_frags(log_buf[3], log_buf[4]);
      break;
    case(LOGGING_FREEBLOCKS):
      printf("Freeing blocks\n");
      break;

      /* 
       * get the blocks from the inode and 0 out inode entries
       */
      first_block = (log_buf[5] == 0) ? 0 : (log_buf[5] / fs->fs_bsize) + 1;
      last_block = (log_buf[4] / fs->fs_bsize);

      printf("\tfirst_block = %d; last_block = %d\n", first_block, last_block);

      /*
       * get the dinode of the file
       */
      printf("\tgetting an inode %d\n", log_buf[3]);
      file_p = ginode(log_buf[3]);

      /*
       * free all the full blocks
       */
      for(k = first_block; k < last_block; k++) {
	/*
	 * set the block to be free in the block map
	 */
	/*	  free_frags(get_block(file_p, k), 8); */

	/*
	 * clear the inode block pointer
	 */
	set_block(file_p, k, 0);
      }

      /*
       * now free any left over fragments
       */
      printf("\tk = %d\n", k);
      printf("\tblock %d\n", get_block(file_p, k));
      printf("\tlogbuf2 %d\n", log_buf[5]);
      if(get_block(file_p, k) != 0) {
	/*	  free_frags(get_block(file_p, k),
		  ((log_buf[2] % fs->fs_bsize)/fs->fs_fsize)+1); */
      }
      set_block(file_p, k, 0);

      break;
    case(LOGGING_SYMLINK):
      printf("Creating a symlink with a short name\n");
      break;

      printf("\tInode: %d\n\tSize: %d\n", log_buf[3], log_buf[4]);
      file_p = ginode(log_buf[3]);
      file_p->di_size = log_buf[4];
      get_buffer_data(fs, log_p, file_p->di_db, &bp, &lbn,
		      j % fs->fs_bsize, log_buf[4]);
      printf("%s\n", file_p->di_db);
      j += log_buf[4];
      inodirty();
      break;
    default:
      break;
    }
    printf("J = %d\n", j);
  }
  

  /*
   * Here we want to update the counts on the cylinder groups, etc.
   */
  
  printf("Updating counts on the cylinder groups\n");
