/* Craig Soules
   soules@andrew.cmu.edu
   Apr, 1999 */

#ifndef __FFS_LOGGING_H__
#define __FFS_LOGGING_H__

/* not certain if all these includes are necessary, but they
   should get the job done for now... */
#include <sys/param.h>
#include <sys/buf.h>
#include <sys/kernel.h>
#include <sys/malloc.h>
#include <sys/mount.h>
#include <sys/proc.h>
#include <sys/syslog.h>
#include <sys/systm.h>
#include <sys/vnode.h>
#include <ufs/ufs/dir.h>
#include <ufs/ufs/quota.h>
#include <ufs/ufs/inode.h>
#include <ufs/ufs/ufsmount.h>
#include <ufs/ffs/fs.h>
#include <ufs/ffs/ffs_extern.h>
#include <ufs/ufs/ufs_extern.h>

#define LOGGING_STARTPOINT   sizeof(int)

#define LOGGING_FREEINODE      0x0001
#define LOGGING_ADDDIRENTRY    0x0002
#define LOGGING_REMDIRENTRY    0x0003
#define LOGGING_CHANGEDIRENTRY 0x0004
#define LOGGING_INCLINKCNT     0x0005
#define LOGGING_ADDINDIRPAGE   0x0006
#define LOGGING_ADDDIRECT      0x0007
#define LOGGING_UPDATEBLKMAP   0x0008
#define LOGGING_UPDATEINOMAP   0x0009
#define LOGGING_MOVDIRENTRY    0x000A
#define LOGGING_SETINDIRMETA   0x000B
#define LOGGING_FREEBLOCKS     0x000C
#define LOGGING_FREEFRAGS      0x000D
#define LOGGING_CHANGESIZE     0x000E
#define LOGGING_SYMLINK        0x000F
#define LOGGING_SETATTR        0x0010
#define LOGGING_MKNOD          0x0011
#define LOGGING_INITDIR        0x0012
#define LOGGING_REALLOCBUF     0x0013
#define LOGGING_ENDLOG         0xFFFFFFFF

void reclaim_log(struct vnode *);
void logging_flush_log_to_buf(struct buf *);
void logging_setup_direct(struct inode *, ufs_lbn_t, ufs_daddr_t,
			  long, struct buf *);
void logging_blkmapdep(struct inode *, struct mount *, ufs_daddr_t, int);
void logging_inomapdep(struct inode *, ino_t, int);
void logging_freefile(struct vnode *, ino_t, int);
void logging_update_inodeblock(struct inode *, struct buf *, int);
int logging_flushlog(struct mount *, int, struct proc *);
int logging_mount(struct vnode *, struct mount *, struct fs *, struct ucred *);
void logging_initialize(void);
void logging_init_directory(struct inode *, struct inode *, struct buf *);
void logging_setup_directory_add(struct inode *, unsigned int, 
				 struct direct *, off_t, struct buf *, int);
void logging_move_directory(struct inode *, unsigned int, struct direct *,
			    off_t, struct buf *, int);
void logging_setup_remove(struct inode *, struct inode *, struct buf *);
void logging_setup_directory_change(struct inode *, struct inode *, long, int,
				    struct buf *);
void logging_increase_linkcnt(struct inode *);
void logging_setup_indir_meta(struct inode *, int, ufs_daddr_t, ufs_daddr_t);
void logging_setup_indir_page(struct inode *, ufs_lbn_t, ufs_daddr_t, int);
void logging_change_size(struct inode *, int);
void logging_setup_freefrags(struct inode *, ufs_daddr_t, long, struct buf *);
void logging_setup_freeblocks(struct inode *, off_t);
void logging_symlink(struct inode *, char *, int);
void logging_setattr(struct inode *);
void logging_mknod(struct inode *);
void logging_realloc_buf(struct inode *, struct buf *, ufs_daddr_t, int, int);

#endif
